procedure Chl (var cruisei  : info;
               var holddata : holdfile);

const
  maxrec = 20;
  avol   = '10';

var
  rec                    : string;
  chlfile                : data;
  Fn, flname             : string;
  procno, castno, depth  : string;
  range, door, stano     : string;
  sample                 : string;
  closefile,goodinput,
  exiit,quitit,newpage   : boolean;
  samp                   : integer;
  fvol                   : string;
  fluor                  : string;
  mfactor, afactor       : string;
  Rb, Ra                 : string;
  pcnt5                  : integer;
  outpath, tempstr       : string;
  holdnum                : integer;

begin
  OutPath := cruisei.path+'chl\';
  Quitit := False;
  stop := false;
  newpage := true;
  closefile := false;
  fluor  := cruisei.fluor;
  Fn := (cruisei.Cruise+'Chla');
  Appendfile(goodinput, outpath, fn, chlfile);
  Where(outpath, pcnt5);
  while newpage do
    begin
      ClrScr;
      FullCursor;
      for i := 1 to maxrec do
        holddata[i] := '';
      Exiit := False;
      newpage := false;
      count := 4;
      samp := 1;
      stano := '';
      rec := '';
      YN := ' ';
      tempstr := ' ';
      str(pcnt5, ProcNo);
      Fillscreen(1,1,80,25,white,blue,chr(0));
      repeat
      MkWin(5, 10, 75, 20,  yellow, cyan, 2);
      WriteAt(16, 12, black, cyan,'            Enter the Proc#: '+ProcNo);
      WriteAt(16, 14, black, cyan,'Enter the Sta# (eg. 93.32) : ');
      WriteAt(16, 16, black, cyan,'Enter the Fluorometer Name : '+cruisei.FLUOR);
      gotoxy(45, 12);
      readln(tempstr);
      if tempstr[1] in ['0'..'9'] then ProcNo := tempstr;
      gotoxy(45, 14);
      readln(Stano);
      gotoxy(45, 16);
      flname := fluor;
      readln(flname);
      if flname = '' then flname := fluor;
      if flname <> fluor then
        begin
          fluor := flname;
          cruisei.fluor := fluor;
        end;
      WriteBetween(5,75,20, Black, cyan, 'Y to Accept, N to Edit');
      WriteAt(33,18,black, cyan, ' OK? (YN) : ');
      GotoXY(45, 18);
      readln(YN);
      until YN in ['y', 'Y','+'];
      rmwin;
      YN := ' ';
      FBox(3,1,77,3,white,blue,177);
      fbox(1,4,80,25,yellow, blue,0);
      door := '1';
      CastNo  := '2';
      range := '100';
      while not(newpage) do
        begin
          str(samp, Sample);
          GoodInput := True;
          Exiit := False;
          if fvol <> '138' then fvol := '142';
          depth := '3';
          Rb := '';
          Ra := '';
          IO_Setfields(8);
          IO_UserHook := @FKeys;
          IO_SetColors(14,0,4,7,14,4);
          IO_AllowEsc(True);
          IO_SoundBeeper(false);
          IO_DefineStr(1, 8,2,8,2,      14,2,  CastNo,  '*#');
          IO_DefineStr(2, 1,3,1,3,      17,2,  sample,  '###');
          IO_DefineStr(3, 2,4,2,4,      21,2,  fvol,    '###');
          IO_DefineStr(4, 3,5,3,5,      25,2,  depth,   '###');
          IO_DefineStr(5, 4,6,4,6,      29,2,  Range,   '###');
          IO_DefineStr(6, 5,7,5,7,      33,2,  door,    '*');
          IO_DefineStr(7, 6,8,6,8,      35,2,  Rb,      '###');
          IO_DefineStr(8, 7,0,7,0,      39,2,  Ra,      '###');
          IO_DefineMsg(1,  14,1,   'Cast');
          IO_DefineMsg(2,  17,1,   'Sample#');
          IO_DefineMsg(3,  21,1,   'FVol');
          IO_DefineMsg(4,  25,1,   'Depth');
          IO_DefineMsg(5,  29,1,   'Sensitivity');
          IO_DefineMsg(6,  33,1,   'Range');
          IO_DefineMsg(7,  35,1,   'Rb');
          IO_DefineMsg(8,  39,1,   'Ra');
          WriteCenter(25,yellow,blue,
'  < F1 > - Help          |    <F2> - Line Editor     | < Esc > - Quit/Save');
          repeat
            exiit := false;
            query := ' ';
            goodinput := true;
            writeat(65,4,yellow,blue ,'Proc#: '+ProcNo);
            IO_Edit(Code);
            if code = 1 then
              exiit := true;
            if exiit then
              begin
                choices(query);
                whattodo(query, goodinput, closefile, newpage, exiit, quitit,
                  cruisei, closeTS);
              end;
             if (Ra = '') and (query = ' ') then
              begin
                Beep;
                repeat
                  ErrorWin ('Last field is empty! Y to accept, N to edit.',YN);
                until YN in ['y','Y', 'n', 'N','+','-'];
                  if YN in ['n','N','-'] then Goodinput := false;
              end;
              YN := ' ';
              if (GoodInput) and (Str_to_int(Ra) > Str_to_Int(Rb))
                and (query = ' ') then
              begin
                Beep;
                repeat
                  ErrorWin ('Ra is larger than Rb?! Y to accept, N to edit.',YN);
                until YN in ['y','Y', 'n', 'N','+','-'];
                  if YN in ['n','N','-'] then Goodinput := false;
              end
              else if (GoodInput and (Str_to_Int(door) > 4) or
                  not(Str_to_int(range) in [1, 100])) then
                     begin
                       Beep;
                       repeat
             ErrorWin ('Check range or door value. Y to accept, N to edit.',YN);
                       until YN in ['y','Y', 'n', 'N','+','-'];
                       if YN in ['n','N','-'] then Goodinput := false;
                     end;
              YN := ' ';
              if GoodInput then
                if ((length(Ra) < 3) or (length(Rb)< 3)) and (query = ' ') then
                  begin
                    Beep;
                    repeat
                      ErrorWin (
               'Length of Ra or Rb is too short! Y to accept, N to edit.',YN);
                    until YN in ['y','Y', 'n', 'N','+','-'];
                if YN in ['y','Y','+'] then
                  repeat
                      if length(Ra) < 3 then Ra := Ra + '0';
                      if length(Rb) < 3 then Rb := Rb + '0';
                    until (length(Ra) = 3) and (length(Rb) = 3);
                    if YN in ['n','N','-'] then Goodinput := false;
                  end;
              YN := ' ';
              query := ' ';
              Fillscreen(1,1,80,1,white,blue,chr(177));
              writeat(1,70,yellow,blue ,'Proc# '+ProcNo);
          until goodinput;  {continue edit}
          if not(newpage) AND not(closefile) AND not(exiit) then
            begin
              Makelength(2, sample);
              Makelength(4, depth);
              Makelength(3, Range);
              Makelength(3, Rb);
              Makelength(3, Ra);
              rec := (CastNo+' '+Sample+' '+depth+'  '+fvol+' '+avol+' '+Range+
          ' '+''''+door+''' '+rb+' '+ra);
              holddata[count-3] := rec;
              count := count + 1;
              stripblanks(sample, code);
              val(sample, samp, code);
              samp := samp + 1;
              if count < 25 then
                  writeat(1,count,yellow,blue ,rec)
              else
                begin
                  ScrollUp(1,5,80,24);
                  writeAt(1,24,yellow, blue, rec);
                end;
              rec := '';
              IO_resetfields;
              Fillscreen(1,1,80,1,white,blue,chr(177));
            end;  {if not(newfile) and Not(exiit)}
          if newpage or closefile then
            begin
              str((samp-1), sample);
              stripblanks(ProcNo,code);
              val(Procno, holdnum, code);
              writeln(Chlfile, stano);
              writeln(Chlfile, fluor);
              Writeln(Chlfile, 'Chla1');
              Writeln(Chlfile, 'Chla2');
              MakeLength(3, ProcNo);
              Writeln(Chlfile, ProcNo+'  '+sample);
              for i := 1 to (count-4) do
                Writeln(Chlfile, holddata[i]);
              AddZeros(procno);
              Writeln(Chlfile, '***'+procno);
              if holdnum < 300 then pcnt5 := holdnum + 1;
              if closefile then
                begin
                  close(chlfile);
                  savewhere(outpath,pcnt5);
                  if not(quitit) then
                     begin
                       IO_resetfields;
                       Menu(cruisei);
                     end
                end;
              IO_resetfields;
              closefile := false;
              newpage := true;
              if quitit then
                begin
                  Halt;
                end;
            end;  {if closefile}
        end;
    end;
end;
