procedure ChopPrdo (var cruisei  : info;
                    var scindata : holdfile);

const
  maxrec = 18;

var
  scinfn, prodofn        : string;
  rec                    : string;
  prdfile, inscin,
  inprodo                : data;
  Fn, hdr1, hdr2         : string;
  procno, castno         : string;
  sample                 : string;
  goodinput,
  exiit                  : boolean;
  code, filerow, rowcnt  : integer;
  Rb, Ra                 : string;
  pcnt9                  : integer;
  temp1, temp2           : string;
  ch                     : char;
  BBlank, EBlank, blank  : string;
  BegB, EndB             : integer;
  blnk, SumBlank         : real;
  noofblnks              : integer;
  Level1, level2,
  level3, level4,
  level5, level6,
  inpath                 : string;

begin
  inpath := cruisei.path+'prodo\';
  scinfn := (inpath+cruisei.cruise+'scin');
  assign(inscin, scinfn);
  reset(inscin);
  prodofn := (inpath+cruisei.cruise+'prod');
  assign(inprodo, prodofn);
  reset(inprodo);
  ClrScr;
  FullCursor;
  for i := 1 to maxrec do
    holddata[i] := '';
  count := 1;
  YN := ' ';
  temp1 := '';
  temp2 := '';
  Fillscreen(1,1,80,25,white,blue,chr(0));
  BBlank := '';
  EBlank := '';
  blank := '';
  blnk := 0;
  noofblnks := 0;
  SumBlank := 0;
  level1 := '94.2';
  level2 := '36.4';
  level3 := '17.3';
  level4 := '4.10';
  level5 := '2.20';
  level6 := '0.17';
  hdr1 := '';
  hdr2 := '';
  rowcnt := 1;
    IO_Setfields(8);
    IO_UserHook := @FKeys;
    IO_SetColors(14,0,4,7,14,4);
    IO_AllowEsc(True);
    IO_SoundBeeper(false);
    IO_DefineStr(1, 8,2,8,2,      40, 8,  Level1,   '#####');
    IO_DefineStr(2, 1,3,1,3,      40, 9,  Level2,   '#####');
    IO_DefineStr(3, 2,4,2,4,      40,10,  Level3,   '#####');
    IO_DefineStr(4, 3,5,3,5,      40,11,  Level4,   '####');
    IO_DefineStr(5, 4,6,4,6,      40,12,  Level5,   '####');
    IO_DefineStr(6, 5,7,5,7,      40,13,  Level6,   '####');
    IO_DefineStr(7, 6,8,6,8,      40,15,  BBlank,   '###');
    IO_DefineStr(8, 7,0,7,0,      40,16,  EBlank,   '###');

    IO_DefineMsg(1,  20,25, 'Enter First Light Level (100x): eg 94.2');
    IO_DefineMsg(2,  20,25, 'Enter Second Light Level (100x): eg 36.4');
    IO_DefineMsg(3,  20,25, 'Enter Third Light Level (100x): eg 17.3');
    IO_DefineMsg(4,  20,25, 'Enter Fourth Light Level (100x): eg  4.10');
    IO_DefineMsg(5,  20,25, 'Enter Fifth Light Level (100x): eg  2.20');
    IO_DefineMsg(6,  20,25, 'Enter Sixth Light Level (100x): eg  0.17');
    IO_DefineMsg(7,  20,25, 'Enter the Beginning Blank Processing #');
    IO_DefineMsg(8,  20,25, 'Enter the Ending Blank Processing #');
    repeat
      MkWin(15,5,65,22, yellow, blue, 2);
      WriteBetween(15,65,6, yellow, blue, 'Prodo Calib');
      WriteAt(29, 8, white, blue,  '  Level 1: ');
      WriteAt(29, 9, white, blue,  '  Level 2: ');
      WriteAt(29, 10, white, blue, '  Level 3: ');
      WriteAt(29, 11, white, blue, '  Level 4: ');
      WriteAt(29, 12, white, blue, '  Level 5: ');
      WriteAt(29, 13, white, blue, '  Level 6: ');
      WriteAt(29, 15, white, blue, ' Beg Blnk: ');
      WriteAt(29, 16, white, blue, ' End Blnk: ');
      exiit := false;
      goodinput := true;
      IO_Edit(Code);
      WriteAt(29, 18, white, blue, 'OK? Y/N/Q: ');
      gotoxy(40, 18);
      ch := getkey;
      if ch in ['y', 'Y','+'] then
          goodinput := true
      else if ch in ['n', 'N','-'] then
          goodinput := false
      else if ch in ['q', 'Q'] then exiit := true;
      ch := ' ';
    until goodinput or exiit;  {continue edit}
    if not(exiit) then
      begin
        hdr1 := (Level1+' '+Level2+' '+Level3+'  '+Level4+' '+Level5+' '+ Level6);
    Stripblanks(BBlank, BegB);
    StripBlanks(EBlank, EndB);
    noofblnks := (EndB-BegB)+1;
    for i := 1 to 12 do
      readln(inscin, rec);

    while not(eof(inscin)) do
      begin
        readln(inscin, rec);
        rowcnt := rowcnt + 1;
        if (rowcnt = (BegB+BegB)) or
         (rowcnt <= (EndB+EndB)) and (rowcnt > (BegB+BegB)) then
        begin
          for I := 15 to 23 do
            blank := blank + rec[I];
          StripBlanks(blank, code);
          val(Blank, blnk, code);
          SumBlank := SumBlank + blnk;
          readln(inscin, rec);
          rowcnt := rowcnt +1;
          blank := '';
        end;
      end;
    Blnk := SumBlank/noofblnks;
    str(blnk:4:1, blank);
    reset(inscin);
    for i := 1 to 12 do
      readln(inscin, rec);
    rowcnt := 1;

    while not(eof(inscin)) and not(eof(inprodo)) do
      begin
        filerow := 1;
        hdr2 := '';
        readln(inprodo, rec);
        fn := 'prd'+rec[1]+rec[2]+rec[3];
        WriteBetween(15,65,22, white, blue, ' Processing File: '+fn+' ');
        for I := 5 to 30 do
          hdr2 := hdr2 + rec[I];
        hdr2 := hdr2+' '+blank;
        repeat
          rowcnt := rowcnt +1;
          if filerow in [1..3] then
          scindata[filerow] := '1 ';
          if filerow in [4..6] then
          scindata[filerow] := '2 ';
          if filerow in [7..9] then
          scindata[filerow] := '3 ';
          if filerow in [10..12] then
          scindata[filerow] := '4 ';
          if filerow in [13..15] then
          scindata[filerow] := '6 ';
          if filerow in [16..18] then
          scindata[filerow] := '8 ';
          readln(inscin, rec);
          rowcnt := rowcnt + 1;
          for I := 15 to 24 do
            temp1 := temp1 + rec[I];
          for I := 48 to 52 do
            temp2 := temp2 + rec[I];

          if (rowcnt < (BegB+BegB+1)) or (rowcnt > (EndB+EndB+1)) then
            begin
              scindata[filerow] := scindata[filerow]+ ' '+temp1 +' '+temp2;
              filerow := filerow + 1;
            end;

          readln(inscin, rec);
          temp1 := '';
          temp2 := '';
        until filerow = 19;
        rec := '';
        Appendfile(goodinput, inpath, fn, prdfile);
        writeln(Prdfile, hdr1);
        writeln(prdfile, hdr2);
        for i := 1 to 18 do
          Writeln(Prdfile, scindata[i]);
        close(prdfile);
        for i := 1 to 18 do
          scindata[i] := '';
     end;
    end; {if not(exiit)...}
    IO_resetfields;
    close(inscin);
    close(inprodo);
    Menu(cruisei);
end;
