{$R+}    {Range checking on}
{$B+}    {Boolean complete evaluation on}
{$S+}    {Stack checking on}
{$I+}    {I/O checking on}
{$N-}    {numeric coprocessor}
{$M 65500,16384,655360} {Default stack and heap}

{****************************************************************************
 **                           PROGRAM CODES                                **
 **                                                                        **
 **  Purpose : Entry of CalCOFI hydrographic data for processing by SSurf  **
 **            Fortran programs.                                           **
 **  Input   : Raw hydrographic data from forms filled during CalCOFI      **
 **            stations.                                                   **
 **  Output  : Formatted raw data files for calculations and merging into  **
 **            data reports by SSurf programs.                             **
 **  Method  : User call appropriate routine and enters values using the   **
 **            number pad.  Therms & salts are saved as individual files.  **
 **            Nutrients, Chloros, & O2s are saved into single files which **
 **            are split after calibration/blank values are calculated.    **
 **                                                                        **
 **                        JRW  version 2.64  20Jan93                      **
 ****************************************************************************}

program Codes (input, output);

uses Crt, DOS, KeyTTT,FastTTT,WinTTT,IOTTT, MiscTTT, StrngTTT, DirTTT, MenuTTT;

const
  maxrec      = 75;
  sp2         = '  ';
  sp3         = '   ';
  BlankCell   = ' ';

type
  Data     = text;
  holdfile = array [1..maxrec] of string;
  Info  = record
    Cruise, ship,
    Fluor,
    Path, InName,
    OutName       : string;
  end;



var
  header             : Data;
  ProgPath           : string;
  BadInput           : boolean;
  onechar            : char;
  I, J, K, L         : integer;
  Code, count        : integer;
  Fr, Fs             : real;
  ch, YN             : char;
  DirInfo            : SearchRec;
  Offset             : real;
  response           : integer;
  stop, quitit, closeTS,
  closefile, goodinput,
  exiit, newfile     : boolean;
  helpres            : string;
  query              : char;
  holddata           : holdfile;
  Store              : info;

{$I ErrorWin}
{$I Choices}
{$I Error}
{ Instruct}
{ Info}
{$I StrpBlnk.pas}
{$I Appndfil}
{$I CheckFil}
{$I ChckNFil}

{$I calhead} {(var temparray : holdfile;
                        Kind  : integer;
                   var RunOne : boolean;
                 var StartNum : integer;
                 var EndNum   : integer;
                     PNum     : string;
                     Liine    : integer);}


{$I chop}    {(datafil : string;
               subdir  : string;
              datatype : integer);}

{$I editor.pas}

{$F+}
{$I FKeys}      {(Ch            : char;
                  FieldID       : integer;
		  var ReturnStr : string);}

{$I MakLngth.pas}
{$I AddZeros.pas}  {(var ProcessNo : string);}
{$I AddSpaces.pas} {(var ProcessNo : string);}

{$I Entered.pas} {(paath : string;
                 var cnt :integer);}

procedure menu(var cruisei : info);forward;

{$I whattodo.pas}  {(var goodinput, YN, closefile, newpage, exiit, quitit)}

{$I Wea.pas} {(var Cruisei : info;}

{$I StaCst.pas}  {(var Cruisei  : info;
                   var holddata : holdfile);}

procedure TAS;
begin
 end;

{$I edhead.pas} {(var  chngstore   : info);}

{$I cstinf.pas} { (var proc : string;
                   var cast : string);}

{$I Therm.pas}
{$I SALT.pas}

{$I Chl} { (var holddata : holdfile);}


{$I Nut}{(var holddata : holdfile);}

{$I OTwo}{(var holddata : holdfile);}

{$I Prodo2.pas}
{$I ChopPrdo.pas}
{$I Menu.pas}

{$F-}
begin  {main}
  Moused := false;
  ClrScr;
  ProgPath:= 'C:\codes';
  Stop := False;
  for I := 1 to maxrec do
    holddata[i] := '';
{.........................  BEGIN CALCULATIONS  ..........................}
  Exiit := False;
  assign(Header, ProgPath+'\codes.hdr');
  reset(Header);                   {opens input file for reading}
  readln(header, store.Cruise);
  if ((store.Cruise = '')or(store.Cruise = '1')) then
    begin
     edhead(store);
    end
  else
    begin
      Readln(header, store.Ship);
      Readln(header, store.Fluor);
      readln(header, store.Path);
    end;
  close(header);
  repeat
    Menu(store);
  until Exiit;
  ClrScr;
end.  {main}