procedure O2 (var cruisei  : info;
              var holddata : holdfile);
const
  maxrec = 40;

var
  rec                    : string;
  O2file                 : data;
  Fn, flname             : string;
  procno, castno         : string;
  vol,
  sample, bottle         : string;
  closefile,goodinput,
  exiit,quitit,newpage   : boolean;
  samp, pcnt3, tempi     : integer;
  outpath                : string;

begin
  OutPath := cruisei.path+'o2\';
  Quitit := False;
  FullCursor;
  stop := false;
  newpage := true;
  closefile := false;
  Fn := (cruisei.Cruise+'O2');
  Appendfile(goodinput, outpath, fn, O2File);
  where(outpath, pcnt3);
  while newpage do
    begin
      ClrScr;
      Exiit := False;
      newpage := false;
      for i := 1 to maxrec do
        holddata[i] := '';
      CastNo  := '2';
      count := 4;
      samp := 1;
      tempi := 0;
      rec := '';
      Fillscreen(1,1,80,25,white,blue,chr(0));
      FBox(3,1,77,3,white,blue,177);
      fbox(1,4,80,25,yellow, blue,0);
          str(pcnt3, ProcNo);
      while not(newpage) do
        begin
          str(samp, Sample);
          GoodInput := True;
          Exiit := False;
          vol := '';
          bottle := '';
          IO_Setfields(5);
          IO_UserHook := @FKeys;
          IO_SetColors(14,0,4,7,14,4);
          IO_AllowEsc(True);
          IO_SoundBeeper(false);
          IO_DefineStr(1, 5,2,5,2, 10,2,  ProcNo,  '###');
          IO_DefineStr(2, 1,3,1,3, 15,2,  CastNo,  '*#');
          IO_DefineStr(3, 2,4,2,4, 19,2,  Sample,  '###');
          IO_DefineStr(4, 3,5,3,5, 24,2,  Bottle,  '****');
          IO_DefineStr(5, 4,0,4,0, 29,2,  Vol,     '#####');
          IO_DefineMsg(1,  10,1,   'Proc#');
          IO_DefineMsg(2,  15,1,   'Cast');
          IO_DefineMsg(3,  19,1,   'Sample#');
          IO_DefineMsg(4,  24,1,   'Flask');
          IO_DefineMsg(5,  29,1,   'Vol');
          WriteCenter(25,yellow,blue,
'<F1> - Entry Commands  |     <F2> - Line Editor       | < Esc > - Quit/Save');
          repeat
            query := ' ';
            exiit := false;
            goodinput := true;
            IO_Edit(Code);
            if code = 1 then
              exiit := true;
            if exiit then 
              begin
                choices(query);
                whattodo(query, goodinput, closefile, newpage, exiit, quitit,
                  cruisei, closeTS);
              end; 
            if (vol = '') and (query = ' ') then
              begin
                Beep;
                repeat
                  ErrorWin ('Last field is empty! Y to accept, N to edit.',YN);
                until YN in ['n','N','y','Y','+','-'];
                  if YN in ['n','N','-'] then Goodinput := false;
              end;
            if ((length(vol) < 4) and (query = ' ') and GoodInput) then
              begin
                Beep;
                repeat
                  ErrorWin ('Length of vol is too short! Y to accept, N to edit.',YN);
                until YN in ['n','N','y','Y','+','-'];
                  if YN in ['n','N','-'] then Goodinput := false;
              end;
            if ((bottle = '') and (query = ' ') and GoodInput) then
              begin
                Beep;
                repeat
                  ErrorWin ('Bottle field is empty! Y to accept, N to edit.',YN);
                until YN in ['n','N','y','Y','+','-'];
                  if YN in ['n','N','-'] then Goodinput := false;
              end;
              YN := ' ';
              query := ' ';
            Fillscreen(1,1,80,1,white,blue,chr(177));
          until goodinput;  {continue edit}
          if not(newpage) AND not(closefile) AND not(exiit) then
            begin
              stripblanks(ProcNo,code);
              if (Str_to_Int(ProcNo) < 300) then val(ProcNo, tempi, code);
              Addzeros(ProcNo);
              MakeLength(2, castno);
              Makelength(3, sample);
              Makelength(4, Bottle);
              if length(Vol) < 4 then
                repeat
                  vol := vol + '0';
                until length(Vol) = 4;
              if (length(Vol) > 4) then vol := vol[1]+'.'+vol[2]+vol[3]+vol[4]+vol[5]
              else vol := '.'+vol;
              rec := (ProcNo+' '+CastNo+' '+Sample+' '+Bottle+' '+Vol);
              holddata[count - 3] := rec;
              count := count + 1;
              stripblanks(sample, code);
              val(sample, samp, code);
              samp := samp + 1;
              if count < 25 then  writeat(1,count,yellow,blue ,rec)
              else
                begin
                  ScrollUp(1,5,80,24);
                  writeAt(1,24,yellow, blue, rec);
                end;
              rec := '';
              IO_resetfields;
              Fillscreen(1,1,80,1,white,blue,chr(177));
            end;  {if not(newfile) and Not(exiit)}
          if newpage or closefile then
            begin
              str((count-4), sample);
              if length(sample)=1 then sample := ' '+sample;
              Writeln(O2File, Sample);
              for i := 1 to (count-4) do
                Writeln(O2File, holddata[i]);
              if (tempi > 0) then str(tempi, ProcNo);
              Addzeros(ProcNo);
              writeln(O2File,'***'+ProcNo);
              if tempi > 0 then
                pcnt3 := tempi + 1;
              savewhere(OutPath, pcnt3);
              if closefile then
                begin
                  close(O2File);
                  if not(quitit) then
                     begin
                       IO_resetfields;
                       Menu(cruisei);
                     end
                end;
              IO_resetfields;
              closefile := false;
              newpage := true;
              if quitit then
                begin
                  Halt;
                end;
            end;  {if closefile}
        end;
    end;
end;